"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var NameManager = /** @class */ (function () {
    function NameManager(tokens) {
        this.tokens = tokens;
        this.usedNames = new Set();
    }
    NameManager.prototype.preprocessNames = function (tokens) {
        try {
            for (var _a = tslib_1.__values(this.tokens.tokens), _b = _a.next(); !_b.done; _b = _a.next()) {
                var token = _b.value;
                if (token.type.label === 'name') {
                    this.usedNames.add(token.value);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var e_1, _c;
    };
    NameManager.prototype.claimFreeName = function (name) {
        var newName = this.findFreeName(name);
        this.usedNames.add(newName);
        return newName;
    };
    NameManager.prototype.findFreeName = function (name) {
        if (!this.usedNames.has(name)) {
            return name;
        }
        var suffixNum = 2;
        while (this.usedNames.has(name + suffixNum)) {
            suffixNum++;
        }
        return name + suffixNum;
    };
    return NameManager;
}());
exports.NameManager = NameManager;
